clear all
close all
clc

% display
hgrad = [ 76 0 153]/255;
hfb2 = [ 153 0 153]/255;
hfb3 = [218 152 207]/255;
hpr = [100 29 29]/255;
hdr = [192 135 70]/255;



% parameters
tau   = logspace(-10,1,1000); % step-size


%% gradient A+ B
alpha = 1;             % A alpha-cocoercive
beta  = 5;             % B beta-cocoercive
rho = 0.9;

rG = sqrt(1 - 2.*tau*rho./(alpha*(2*beta-tau)).*(2*beta*alpha - tau*(beta+alpha)));
rG(tau>2*alpha*beta/(beta+alpha))=NaN;
figure(1);plot(tau,rG,'linewidth',2,'Color',hgrad,'LineStyle','--');hold on;

rG = max(abs(1-tau.*rho),abs(1-tau*(1/beta+1/alpha)));
rG(tau>2*alpha*beta/(beta+alpha))=NaN;
figure(1);plot(tau,rG,'linewidth',2,'Color',hgrad);hold on;
    
rG = sqrt(1 - tau*rho./(alpha).*(2*alpha - tau));
rG(tau>2*alpha)=NaN;
figure(1);hold on; plot(tau,rG,'linewidth',2,'Color',hfb2,'LineStyle','--');hold on;

rG = max(abs(1-tau.*rho),abs(1-tau/alpha));
rG(tau>2*alpha)=NaN;
figure(1);hold on; plot(tau,rG,'linewidth',2,'Color',hfb2);hold on;

rG = (1./(1+ tau*rho));
rG(tau>2*beta)=NaN;
figure(1);plot(tau,rG,'linewidth',2,'Color',hfb3);hold on;

rG = sqrt((alpha-2*tau.*rho*alpha +tau.^2*rho)./(alpha + 2*tau*rho*alpha+tau.^2*rho));
figure(1);plot(tau,rG,'linewidth',2,'Color',hpr,'LineStyle','--');hold on;

rG = max((1-tau*rho)./(1+tau*rho),(tau/alpha -1)./(tau/alpha+1));
figure(1);plot(tau,rG,'linewidth',2,'Color',hpr);hold on;


rG = 1/2+1/2*sqrt((alpha-2*tau.*rho*alpha +tau.^2*rho)./(alpha + 2*tau*rho*alpha+tau.^2*rho));
figure(1);plot(tau,rG,'linewidth',2,'Color',hdr,'LineStyle','--');hold on;

rG = 1/2 + 1/2*max((1-tau*rho)./(1+tau*rho),(tau/alpha -1)./(tau/alpha+1));
rG = min(rG,(beta+tau.^2.*rho)./(beta + tau.*beta.*rho +tau.^2.*rho));
figure(1);plot(tau,rG,'linewidth',2,'Color',hdr);hold on;

grid on;
ylim([0 1]);
%legend('1-Gradient Monotone Operator','1-Gradient Optimisation','2-FB Monotone Operator', '2-FB Optimisation','3-FB','4-PR','5-DR');
tit = title('$\alpha=1$, $\beta=5$, $\rho = 0.9$');
tit.FontSize = 20;
tit.Interpreter= 'latex';