clear all
close all
clc

% load data
hgrad = [ 0 0 204]/255;
hfb2  = [ 153 0 153]/255;
hfb3  = [255 51 153]/255;
hpr   = [100 29 29]/255;
hdr   = [192 135 70]/255;

% C
%%
%
sx = 200
alpha=1;
beta_list1 = 10.^(linspace(-4,4,sx));
rho_list = 10.^(linspace(-4,0,sx))/alpha;
bb=1;
for beta = beta_list1;%10.^(linspace(-3,2,10))
    rr=1;
    for rho = rho_list;%10.^(linspace(-3,2,10))


        tau        = 2*beta;
        rFB2 = 1./(1+ tau*rho);
        rFB2(tau>2*beta)=NaN;

        rate_FB2(rr,bb) = rFB2;    

        % propri?t?s PR
        % :prox_l2+hubL2 et prox hubL1 
        tau        = sqrt(alpha./rho);
        %rPR = sqrt((alpha_pr-2*tau.*rho_pr*alpha_pr +tau.^2*rho_pr)./(alpha_pr + 2*tau*rho_pr*alpha_pr+tau.^2*rho_pr));
%            rPR = (1-sqrt(alpha*rho))./(1+sqrt(alpha*rho));%)max((1-tau*rho)./(1+tau*rho),(tau./alpha -1)./(tau./alpha+1));
         rPR = max((1-tau*rho)./(1+tau*rho),(tau./alpha -1)./(tau./alpha+1));
        rate_PR(rr,bb) = rPR;    

        % propri?t?s DR
        % :prox_l2+hubL2 et prox hubL1
        if beta<=4*alpha
            tau        = sqrt(alpha/rho);
        else
            tau       = sqrt(beta/rho);
        end
        %rDR = 1/2+1/2*sqrt((alpha_dr-2*tau.*rho_dr*alpha_dr +tau.^2*rho_dr)./(alpha_dr + 2*tau*rho_dr*alpha_dr+tau.^2*rho_dr));
        rDR = 1/2 + 1/2*max((1-tau*rho)./(1+tau*rho),(tau./alpha -1)./(tau./alpha+1));
        rDR = min(rDR, (beta + tau.^2*rho)./(beta + tau*beta*rho + tau.^2*rho));
        rate_DR(rr,bb) = rDR;  
        
        
        [~,min_v(rr,bb)] = min([rate_FB2(rr,bb),rate_DR(rr,bb),rate_PR(rr,bb)]);
        rr=rr+1;
    end
    bb=bb+1;
end
figure(1)
subplot(2,3,1); imagesc(flipud(rate_FB2),[0,1]);title 'FBS rate'
subplot(2,3,2); imagesc(flipud(rate_DR),[0,1]);title 'DRS rate'
subplot(2,3,3); imagesc(flipud(rate_PR),[0,1]);title 'PRS rate'

subplot(2,3,4); imagesc(flipud(min(min(rate_DR,rate_PR),rate_FB2)),[0,1]);title 'Optimal rate'
subplot(2,3,5); imagesc(flipud(min_v));title 'Optimal method FBS/DRS/PRS'
subplot(2,3,6); imagesc(flipud(rate_DR-rate_PR)); title 'Diff DRS-PRS rates'
%

%%
tmp = min(min(rate_DR,rate_PR),rate_FB2);
p = pink;a = autumn; c = copper;
res = zeros(sx,sx);
for i=1:sx;
    for j=1:sx
        if min_v(i,j)==1
            res(i,j,:) = tmp(i,j);%*[0.6235,0.5255,0.5255]/0.6235;
        elseif min_v(i,j)==2
            res(i,j,:) = tmp(i,j);%*[255 178 102]/255;
        elseif min_v(i,j)==3
            res(i,j,:) = tmp(i,j);%*[201,164, 146]/201;
        end
    end
end
figure(101)
imshow(flipud(res))

dif1 = diff(min_v);
dif2 = diff(min_v')';
dif = [dif1;zeros(1,sx)]+[dif2,zeros(sx,1)];
res2 = zeros(sx,sx,3);
for i=1:sx;
    for j=1:sx
        if abs(dif(i,j))>0
            res2(i,j,1)=1;
        else
            res2(i,j,:) = [res(i,j),res(i,j),res(i,j)];
        end
    end
end
figure(10);imshow(flipud(res2))

%%
figure(2)
imagesc(flipud(min(min(rate_DR,rate_PR),rate_FB2)),[0,1]); axis image off; colormap(gray)
