clear all
%close all
clc

addpath(genpath('data'));
addpath(genpath('include'));
%%
hgrad = [ 76 0 153]/255;
hfb2  = [ 153 0 153]/255;
hfb3a = [218 152 207]/255;
hfb3b = [255 0 127]/255;
hpr   = [100 29 29]/255;
hdr   = [192 135 70]/255;


% load data
n    = 200;
%real = 1;
%p    = 0.08;
%[b,x0] = create_piecewise_cst_1D(n,p,0.07);
load data/signal1D_200_v2.mat 
x0 = 10*x0;
b = x0+0.7*randn(size(x0));
        
        
        
t = ones(n,1);
D = spalloc(n,n,10*n);
D = spdiags(t/2,0,n,n) + spdiags(-t/2,1,n,n); 
disp('no per'); disp(min(eig(D'*D)));
nD = norm(full(D))^2;
nD1 = norm(full(D(1:2:end,:)))^2;
nD2 = norm(full(D(2:2:end,:)))^2;

A = 1;
op.direct       = @(x) D*x;
op.adjoint      = @(x) D'*x;
op1.direct       = @(x) D(1:2:end,:)*x;
op1.adjoint      = @(x) D(1:2:end,:)'*x;
op2.direct       = @(x) D(2:2:end,:)*x;
op2.adjoint      = @(x) D(2:2:end,:)'*x;
D1 = diag(full(D(1:2:end,:)*D(1:2:end,:)'));
D2 = diag(full(D(2:2:end,:)*D(2:2:end,:)'));


        
for lambda= [0.7]
    for rhohub = 0.002%[0.0001]


        nb_it =500000;
 
        %%PR infty
        disp('xinfty');
        alpha_pr      = 1/(1+1/rhohub*nD2*lambda);  
        rho_pr        = 1; 
        beta_pr       = 1/(1/rhohub*nD1*lambda); 
        gamma_pr      = sqrt(alpha_pr/rho_pr);               

        [~,initgrad] = estimate_huber_op(b', 0, rhohub, op1);
        xn = b'+gamma_pr*lambda*initgrad;
        for it=1:nb_it 
            yn = xn - op1.adjoint(1./D1.*(op1.direct(xn) - prox_huberl2_matrix(op1.direct(xn), rhohub, gamma_pr*lambda*D1)));

            tmp = (2*yn-xn + gamma_pr*b')/(1+gamma_pr);
            zn = tmp - op2.adjoint(1./D2.*(op2.direct(tmp) - prox_huberl2_matrix(op2.direct(tmp), rhohub, gamma_pr*lambda.*D2./(1+gamma_pr))));
            xn = 2*zn - (2*yn-xn);

            crit_prbar(it) = 1/2*sum((A*yn(:)-b(:)).^2) + lambda*function_huberl2(op.direct(yn),rhohub) ;    
        end
        xbarpr = xn;
        rate0pr = norm(b(:)+gamma_pr*lambda*initgrad(:) - xbarpr(:),'fro');  
        ybar = yn;   
        rate0 = norm(b(:) - ybar(:),'fro');   
        
        %% DR infty
        disp('xinfty');
        alpha_dr      = 1/(1+1/rhohub*nD2*lambda);  
        rho_dr        = 1; 
        beta_dr       = 1/(1/rhohub*nD1*lambda);
        if beta_dr<4*alpha_dr/(1+sqrt(1-alpha_dr*rho_dr)^2)
            gamma_dr      = sqrt(alpha_dr/rho_dr);
        else
            gamma_dr      = sqrt(beta_dr/rho_dr);
        end                

        [~,initgrad] = estimate_huber_op(b', 0, rhohub, op1);
        xn = b'+gamma_dr*lambda*initgrad;

        for it=1:nb_it 
            yn = xn - op1.adjoint(1./D1.*(op1.direct(xn) - prox_huberl2_matrix(op1.direct(xn), rhohub, gamma_dr*lambda*D1)));

            tmp = (2*yn-xn + gamma_dr*b')/(1+gamma_dr);
            zn = tmp - op2.adjoint(1./D2.*(op2.direct(tmp) - prox_huberl2_matrix(op2.direct(tmp), rhohub, gamma_dr*lambda.*D2./(1+gamma_dr))));
            xn = xn + zn-yn;     

            crit_drbar(it) = 1/2*sum((A*yn(:)-b(:)).^2) + lambda*function_huberl2(op.direct(yn),rhohub) ;    
        end   
        xbardr = xn;
        rate0dr = norm(b'+gamma_dr*lambda*initgrad(:) - xbardr(:),'fro');                


        %%
        nn=1;
        for nb_it =[10,100,20000]
        disp('gradient');
        zn = b';
        alpha_grad      = 1;  
        rho_grad        = 1; 
        beta_grad       = 1/(1/rhohub*nD*lambda); 
        gamma_grad = 2/(rho_grad+1/alpha_grad + 1/beta_grad);

        for it=1:nb_it
            rate_grad(it) = norm(zn(:)-ybar(:));
            [crit1,grad1] = estimate_l2(zn, b, A);
            [crit2,grad2] = estimate_huber_op(zn, 0, rhohub, op);
            crit_grad(it) = crit1 + lambda*crit2 ;
            zn =  zn - gamma_grad*(grad1 + lambda*grad2);
        end
        yn_grad = zn;               


        %% Forward-backward (2-):prox_hubL1 et grad l2+hubL2
        disp('forward-backward 2-');
        % FB : x0 = b et ||xn - ybar|| et ||x0 - ybar||           
        xn =b';
        alpha_fb2      = 1/(1+1/rhohub*nD2*lambda); 
        rho_fb2        = 1; 
        beta_fb2       = 1/(1/rhohub*nD1*lambda);   
        gamma_fb2      = 2/(rho_fb2+1/alpha_fb2);

        for it=1:nb_it
            rate_fb2(it) = norm(xn(:)-ybar(:));
            [crit1,grad1] = estimate_huber_op(xn, 0, rhohub, op2);
            crit2 = function_huberl2(op1.direct(xn),rhohub);
            [crit3,grad3] = estimate_l2(xn, b, A);
            crit_fb2(it) = crit3 + lambda*crit2 + lambda* crit1;   
            tmp = xn - gamma_fb2*(lambda*grad1 +grad3);
            xn = tmp - op1.adjoint(1./D1.*(op1.direct(tmp) - prox_huberl2_matrix(op1.direct(tmp), rhohub, gamma_fb2*lambda*D1)));

        end
        yn_fb2 = xn;

        %% Forward-backward (3-): prox_l2 et grad hub
        disp('forward-backward 3a');
        xn = b';
        alpha_fb3a     = 1;  
        rho_fb3a       = 1;  
        beta_fb3a      = 1/(1/rhohub*nD*lambda);   
        gamma_fb3a     = 1.99*beta_fb3a;

        Minv = 1/(1+ gamma_fb3a);
        for it=1:nb_it
            rate_fb3a(it) = norm(xn(:)-ybar(:));
            [crit2,grad2] = estimate_huber_op(xn, 0, rhohub, op);
            crit_fb3a(it) = 1/2*sum((A*xn(:)-b(:)).^2) + lambda*crit2 ;   
            xn = prox_l2diff(xn-gamma_fb3a*lambda*grad2, b, A,gamma_fb3a,Minv);
        end
        yn_fb3a = xn;


        %% Forward-backward (3-):prox_l2+hubL2 et grad hubL1
        disp('forward-backward 3b'); 
        % FB : x0 = b et ||xn - ybar|| et ||x0 - ybar||           
        alpha_fb3b      = 1/(1+1/rhohub*nD2*lambda);  
        rho_fb3b        = 1; 
        beta_fb3b       = 1/(1/rhohub*nD1*lambda);  
        gamma_fb3b      = 2*beta_fb3b;
        xn =b';
        for it=1:nb_it
            rate_fb3b(it) = norm(xn(:)-ybar(:));
            [crit1,grad1] = estimate_huber_op(xn, 0, rhohub, op1);
            crit2 = function_huberl2(op2.direct(xn),rhohub);
            [crit3,~] = estimate_l2(xn, b, A);
            crit_fb3b(it) = crit3 + lambda*crit2 + lambda* crit1;   
            tmp = (xn - gamma_fb3b*(lambda*grad1) + gamma_fb3b*b')/(1+gamma_fb3b);
            xn = tmp - op2.adjoint(1./D2.*(op2.direct(tmp) - prox_huberl2_matrix(op2.direct(tmp), rhohub, gamma_fb3b*lambda.*D2./(1+gamma_fb3b))));
        end
        yn_fb3b = xn;



        %% Peaceman-Rachford
        disp('Peaceman-Rachford');
        alpha_pr      = 1/(1+1/rhohub*nD2*lambda);  
        rho_pr        = 1; 
        beta_pr       = 1/(1/rhohub*nD1*lambda); 
        gamma_pr      = sqrt(alpha_pr/rho_pr);
        [~,initgrad]  = estimate_huber_op(b', 0, rhohub, op1);
        xn = b'+gamma_pr*lambda*initgrad;
        rate0pr = norm(xn - xbarpr(:),'fro');                
        for it=1:nb_it
            rate_pr(it) = norm(xn(:) - xbarpr(:),'fro');  %% ATTENTION LE xbar n'est probablement pas le bon

            yn = xn - op1.adjoint(1./D1.*(op1.direct(xn) - prox_huberl2_matrix(op1.direct(xn), rhohub, gamma_pr*lambda*D1)));                   

            tmp = (2*yn-xn + gamma_pr*b')/(1+gamma_pr);
            zn = tmp - op2.adjoint(1./D2.*(op2.direct(tmp) - prox_huberl2_matrix(op2.direct(tmp), rhohub, gamma_pr*lambda.*D2./(1+gamma_pr))));
            xn = 2*zn-(2*yn-xn);  


            crit_pr(it) = 1/2*sum((A*yn(:)-b(:)).^2) + lambda*function_huberl2(op.direct(yn),rhohub) ;    
        end
        yn_pr = yn;

        %% Douglas-Rachford
        disp('Douglas-Rachford');
        alpha_dr      = 1/(1+1/rhohub*nD2*lambda);  
        rho_dr        = 1; 
        beta_dr       = 1/(1/rhohub*nD1*lambda);    
        if beta_dr<4*alpha_dr/(1+sqrt(1-alpha_dr*rho_dr)^2)
            gamma_dr      = sqrt(alpha_dr/rho_dr);
        else
            gamma_dr      = sqrt(beta_dr/rho_dr);
        end
        [~,initgrad] = estimate_huber_op(b', 0, rhohub, op1);
        xn = b'+gamma_dr*lambda*initgrad;
        rate0dr = norm(xn - xbardr(:),'fro');                
        for it=1:nb_it
            rate_dr(it) = norm(xn(:) - xbardr(:),'fro');  %% ATTENTION LE xbar n'est probablement pas le bon

            yn = xn - op1.adjoint(1./D1.*(op1.direct(xn) - prox_huberl2_matrix(op1.direct(xn), rhohub, gamma_dr*lambda*D1)));                   
            tmp = (2*yn-xn + gamma_dr*b')/(1+gamma_dr);
            zn = tmp - op2.adjoint(1./D2.*(op2.direct(tmp) - prox_huberl2_matrix(op2.direct(tmp), rhohub, gamma_dr*lambda.*D2./(1+gamma_dr))));
            xn = xn + zn-yn;  

            crit_dr(it) = 1/2*sum((A*yn(:)-b(:)).^2) + lambda*function_huberl2(op.direct(yn),rhohub) ;    
        end
        yn_dr = yn;




        if nn == 1
            figure(1);hold on;
            subplot(131);
            plot(b,'Color',[0.8,0.8, 0.8]); hold on; plot(x0,'k');
            plot(yn_grad,'Color',hgrad,'Linewidth',1.2);
            plot(yn_fb3a,'Color',hfb3a,'Linestyle','--','Linewidth',1.2);
            plot(yn_fb2,'Color',hfb2,'Linewidth',1.2);              
            plot(yn_fb3b,'Color',hfb3b,'Linestyle','--','Linewidth',1.2);
            plot(yn_pr,'Color',hpr,'Linewidth',1.2);
            plot(yn_dr,'Color',hdr,'Linewidth',1.2);
            %              plot(yn_dr3,'Color',col(7,:),'Linestyle','--');
            grid on;
            title '10 iterations';
        elseif nn==2
            figure(1);hold on;
            subplot(132);
            plot(b,'Color',[0.8,0.8, 0.8]); hold on; plot(x0,'k');
            plot(yn_grad,'Color',hgrad,'Linewidth',1.2);
            plot(yn_fb3a,'Color',hfb3a,'Linestyle','--','Linewidth',1.2);
            plot(yn_fb2,'Color',hfb2,'Linewidth',1.2);  
            plot(yn_fb3b,'Color',hfb3b,'Linestyle','--','Linewidth',1.2);
            plot(yn_pr,'Color',hpr,'Linewidth',1.2);
            plot(yn_dr,'Color',hdr,'Linewidth',1.2);
            %              plot(yn_dr3,'Color',col(7,:),'Linestyle','--');
            grid on;
            title '100 iterations';
        elseif nn==3
            figure(1);hold on;
            subplot(133);
            plot(b,'Color',[0.8,0.8, 0.8]); hold on; plot(x0,'k');
            plot(yn_grad,'Color',hgrad,'Linewidth',1.2);
            plot(yn_fb3a,'Color',hfb3a,'Linestyle','--','Linewidth',1.2);
            plot(yn_fb2,'Color',hfb2,'Linewidth',1.2); 
            plot(yn_fb3b,'Color',hfb3b,'Linestyle','--','Linewidth',1.2);
            plot(yn_pr,'Color',hpr,'Linewidth',1.2);
            plot(yn_dr,'Color',hdr,'Linewidth',1.2);
            %              plot(yn_dr3,'Color',col(7,:),'Linestyle','--');
            grid on;
            title '10000 iterations'; 
        end
        nn=nn+1;


        end
        tit = ['results_section3/ResultsSection312_signal_lambda',num2str(lambda),'_rho',num2str(rhohub)];
        titsignal = [tit,'_Signal.eps'];
        print(titsignal,'-deps');
        save([tit,'.mat']);
    end
end


lgd = legend('Noisy','Original','1-EA','2-FBS', '3-FBS2', ...
                '4-FBS3', '5-PRS','6-DRS');
lgd.FontSize = 18;
            

% proprietes de Grad
tau      = gamma_grad;
rG       = max(abs(1-tau.*rho_grad),abs(1-tau*(1/beta_grad+1/alpha_grad)));
rG(tau>2*alpha_grad*beta_grad/(beta_grad+alpha_grad))=NaN;

% proprietes FB2
% Forward-backward (2-):prox_hubL1 et grad l2+hubL2 
tau        = gamma_fb2;
rFB2       = max(abs(1-tau.*rho_fb2),abs(1-tau/alpha_fb2));
rFB2(tau>2*alpha_fb2)=NaN;
 
% proprietes FB3a
% Forward-backward (3-): prox_l2 et grad hub  
tau        = gamma_fb3a;
rFB3a = 1./(1+ tau*rho_fb3a);
rFB3a(tau>2*beta_fb3a)=NaN;

% propri?t?s FB3b
% Forward-backward (3-):prox_l2+hubL2 et grad hubL1 
tau        = gamma_fb3b;
rFB3b = (1./(1+ tau*rho_fb3b));
rFB3b(tau>2*beta_fb3b)=NaN;

% propri?t?s PR
% :prox_l2+hubL2 et prox hubL1 
tau        = gamma_pr;
%rPR = sqrt((alpha_pr-2*tau.*rho_pr*alpha_pr +tau.^2*rho_pr)./(alpha_pr + 2*tau*rho_pr*alpha_pr+tau.^2*rho_pr));
rPR = max((1-tau*rho_pr)./(1+tau*rho_pr),(tau/alpha_pr -1)./(tau/alpha_pr+1));

% propri?t?s DR
% :prox_l2+hubL2 et prox hubL1
tau        = gamma_dr;
%rDR = 1/2+1/2*sqrt((alpha_dr-2*tau.*rho_dr*alpha_dr +tau.^2*rho_dr)./(alpha_dr + 2*tau*rho_dr*alpha_dr+tau.^2*rho_dr));
rDR = 1/2 + 1/2*max((1-tau*rho_dr)./(1+tau*rho_dr),(tau/alpha_dr -1)./(tau/alpha_dr+1));
rDR = min(rDR, (beta_dr + tau.^2*rho_dr)./(beta_dr + tau*beta_dr*rho_dr + tau.^2*rho_dr));

%%             

                
figure(10);clf
semilogy(rate_grad,'Color',hgrad,'Linewidth',2);
hold on
semilogy(rate_fb3a,'Color',hfb3a,'LineStyle','--','Linewidth',1.2);
semilogy(rate_fb2,'Color',hfb2,'Linewidth',1.2);
semilogy(rate_fb3b,'Color',hfb3b,'LineStyle','--','Linewidth',1.2);
semilogy(rate_pr,'Color',hpr,'Linewidth',1.2);
semilogy(rate_dr,'Color',hdr,'Linewidth',1.2);


    
hold on
it = 0:length(rate_grad)-1;
semilogy(rG.^(it).*rate0,'Color',hgrad,'Linewidth',4)

it = 0:length(rate_fb3a)-1;
semilogy(rFB3a.^(it).*rate0,'Color',hfb3a,'Linewidth',2,'LineStyle','-.')

it = 0:length(rate_fb2)-1;
semilogy(rFB2.^(it).*rate0,'Color',hfb2,'Linewidth',2)


it = 0:length(rate_fb3b)-1;
semilogy(rFB3b.^(it).*rate0,'Color',hfb3b,'Linewidth',2,'LineStyle','-.')

it = 0:length(rate_pr)-1;
semilogy(rPR.^(it).*rate0pr,'Color',hpr,'Linewidth',2,'LineStyle','-.')

it = 0:length(rate_dr)-1;
semilogy(rDR.^(it).*rate0dr,'Color',hdr,'Linewidth',2,'LineStyle','-.')

%it = 0:length(rate_dr3)-1;
%semilogy(rDR_Jsm_Jmoy3.^(it).*rate0dr3,'Color',col(7,:),'Linewidth',2)

xlim([0 6e3]);
ylim([1.79329634085052e-12 2]);
lgd =  legend('Exp. 1-EA','Exp. 2-FBS', 'Exp. 3-FBS2', ...
                'Exp. 4-FBS3', 'Exp. 5-PRS','Exp. 6-DRS',...
                    'Th. 1-EA', 'Th. 2-FBS', 'Th. 3-FBS2', ...
                'Th. 4-FBS3', 'Th. 5-PRS','Th. 6-DRS');
            lgd.FontSize=16;
titrate = [tit,'_Rate.eps'];
print(titrate,'-deps');  
grid on;

