clear all
close all
clc

addpath(genpath('data'));
addpath(genpath('include'));
%
% load data
hgrad = [ 0 0 204]/255;
hfb2 = [ 153 0 153]/255;
hfb3 = [255 51 153]/255;
hpr = [100 29 29]/255;
hdr = [192 135 70]/255;
col = hsv(7);


x0 = (imread('IMG_5885.jpg'));
x0 = double(rgb2gray(x0));
x = x0(762:2:888,923:3:1112);
sx = sqrt(numel(x));
figure(1); subplot(151); imagesc(x); axis image off; colormap(gray);



load filter_gaussian_7_5_N64.mat
[sx1,sy1] = size(A);
A = randn((sqrt(sx1))^2,sy1);
ev = eig(A'*A);
A = A/sqrt(max(ev));
ev = eig(A'*A);
vpmin = min(ev);
vpmax = max(ev);

alpha  = vpmax;
rho    = vpmin;
sig = 10;

dwtmode('per');
prox.rm = 3;
prox.wav = 'sym3';
mask = mask_param(log2(sx),prox.rm,prox.wav)+1e-16; 

for lambda = 1e1 %[1e1,4*1e-2,1e-3]
    for rhohub =1

        beta   = rhohub/lambda;



        % create data

        b = A*x(:)  + sig*randn(numel(A*x(:)),1);
        sb = sqrt(numel(b));

        op.direct       = @(x) mask.*amr2D_vect(reshape(x,sx,sx),prox.rm,prox.wav);
        op.adjoint      = @(x) reshape(iamr2D_vect(x./mask,prox.rm,prox.wav),sx^2,1);
        x0algo =A'*b;
        figure(1); subplot(152); imagesc(reshape(b,sb,sb)); axis image off; colormap(gray);

        nb_it =500;
        nb_it_red = 200;

        % Forward-backward Ref
        disp('Forward-backward');
        xn =x0algo;

        gamma_fb3 =1.9*beta;
        IplusAAinv = inv(eye(sx^2,sx^2)+ gamma_fb3.*A'*A);
        for it=1:nb_it

            crit2 = function_huberl2(op.direct(xn),rhohub);
            crit1 = 1/2*norm(A*xn-b,'fro')^2;

            grad1 = op.adjoint(grad_huberl2(op.direct(xn),rhohub));
            xn = IplusAAinv*(xn - gamma_fb3*lambda*grad1 +gamma_fb3 *A'*b);
            critfbinf(it) = crit1 + lambda* crit2;   
        end
        ybar = xn;
        rate0_fb = norm(x0algo(:)-ybar(:));


        % Peaceman-Rachford Ref
        disp('Peaceman-rachford');

        gamma_pr = sqrt(alpha/rho);  
        IplusAAinv = (eye(sx^2,sx^2)+ gamma_pr.*A'*A);
        xn0 = x0algo+gamma_pr*A'*(A*x0algo-b);  
        xn = xn0;
        for it=1:nb_it
            yn = IplusAAinv\(xn +gamma_pr*A'*b);
            zn = op.adjoint(prox_huberl2(op.direct(2*yn-xn), rhohub, gamma_pr*lambda.*mask.^2));
            xn = 2*zn-(2*yn-xn);  

            crit2 = function_huberl2(op.direct(yn),rhohub);
            critprinf(it) = 1/2*norm(A*yn-b,'fro')^2 + lambda*crit2;   
        end
        xbarpr = xn;
        rate0_pr = norm(xn0(:)-xbarpr(:));    
 


        % Douglas-Rachford Ref
        disp('douglas-rachford');

        if beta<=4*alpha
            gamma_dr        = sqrt(alpha/rho);
        else
            gamma_dr       = sqrt(beta/rho);
        end
        IplusAAinv = eye(sx^2,sx^2)+ gamma_dr.*A'*A;
        xn0 = x0algo+gamma_dr*A'*(A*x0algo-b);    
        xn = xn0;
        for it=1:nb_it
            yn = IplusAAinv\(xn +gamma_dr*A'*b);
            zn = op.adjoint(prox_huberl2(op.direct(2*yn-xn), rhohub, gamma_dr*lambda.*mask.^2));
            xn = xn + zn-yn; 

            crit2 = function_huberl2(op.direct(yn),rhohub);
            critdrinf(it) = 1/2*norm(A*yn-b,'fro')^2 + lambda*crit2;   

        end
        xbardr = xn;
        rate0_dr = norm(xn0(:)-xbardr(:));  






        %%
        disp('3-forward-backward');

        gamma_fb3 =1.9*beta;
        IplusAAinv = inv(eye(sx^2,sx^2)+ gamma_fb3.*A'*A);
        xn = x0algo;
        for it=1:nb_it
            rate_fb3(it) = norm(xn(:)-ybar(:));
            crit2 = function_huberl2(op.direct(xn),rhohub);
            crit1 = 1/2*norm(A*xn-b,'fro')^2;

            grad1 = op.adjoint(grad_huberl2(op.direct(xn),rhohub));
            xn = IplusAAinv*(xn - gamma_fb3*lambda*grad1 +gamma_fb3 *A'*b);

            crit_fb3(it) = crit1 + lambda* crit2;   
        end
        yn_fb3 = xn;



        %% Peaceman-Rachford
        disp('4- Peaceman-Rachford');

        gamma_pr = sqrt(alpha/rho);  
        IplusAAinv = inv(eye(sx^2,sx^2)+ gamma_pr.*A'*A);
        xn0 = x0algo+gamma_pr*A'*(A*x0algo-b);  
        xn = xn0;
        for it=1:nb_it
            rate_pr(it) = norm(xn(:)-xbarpr(:));

            yn = IplusAAinv*(xn +gamma_pr*A'*b);
            zn = op.adjoint(prox_huberl2(op.direct(2*yn-xn), rhohub, gamma_pr*lambda.*mask.^2));
            xn = 2*zn-(2*yn-xn);  

            crit2 = function_huberl2(op.direct(yn),rhohub);
            crit_pr(it) = 1/2*norm(A*yn-b,'fro')^2 + lambda*crit2;   
        end
        yn_pr = yn;



        %% Douglas-Rachford
        disp('5- Douglas-rachford');

        if beta<=4*alpha
            gamma_dr        = sqrt(alpha/rho);
        else
            gamma_dr       = sqrt(beta/rho);
        end
        IplusAAinv = inv(eye(sx^2,sx^2)+ gamma_dr.*A'*A);
        xn0 = x0algo+gamma_dr*A'*(A*x0algo-b);    
        xn = xn0;
        for it=1:nb_it
            rate_dr(it) = norm(xn(:)-xbardr(:));
            yn = IplusAAinv*(xn +gamma_dr*A'*b);
            zn = op.adjoint(prox_huberl2(op.direct(2*yn-xn), rhohub, gamma_dr*lambda.*mask.^2));
            xn = xn + zn-yn; 

            crit2 = function_huberl2(op.direct(yn),rhohub);
            crit_dr(it) = 1/2*norm(A*yn-b,'fro')^2 + lambda*crit2;   

        end
        yn_dr = yn;
        save(['Compare_rate_all_lambda',num2str(lambda),'_rho',num2str(rhohub),'_N64_random_wavl1bis.mat']);

    end


end

%%
figure(100)
subplot(121);imagesc(reshape(x,sx,sx));axis image off;colormap(bone);  title 'Original'
subplot(122);imagesc(reshape(yn_dr,sx,sx));axis image off ;colormap(bone);title 'Restored'




%%

% FB3
rho_fb3 = rho;
tau        = gamma_fb3;
rFB3 = 1./(1+ tau*rho_fb3);
rFB3(tau>2*beta)=NaN;


% PR
rho_pr = rho;
tau        = gamma_pr;
rPR = sqrt((alpha-2*tau.*rho_pr*alpha +tau.^2*rho_pr)./(alpha + 2*tau*rho_pr*alpha+tau.^2*rho_pr));

% DR
rho_dr = rho;
tau        = gamma_dr;
rDR = 1/2+1/2*sqrt((alpha-2*tau.*rho_dr*alpha +tau.^2*rho_dr)./(alpha + 2*tau*rho_dr*alpha+tau.^2*rho_dr));
rDR = min(rDR,(beta+tau.^2.*rho_dr)./(beta + tau.*beta.*rho_dr +tau.^2.*rho_dr));

%%

ax =figure(10);clf
semilogy(rate_fb3,'Color',hfb3,'Linewidth',1);hold on
semilogy(rate_pr,'Color',hpr,'Linewidth',1);
semilogy(rate_dr,'Color',hdr,'Linewidth',1);



hold on

it = 0:length(rate_fb3)-1;
semilogy(rFB3.^(it).*rate0_fb,'Color',hfb3,'Linewidth',3,'LineStyle','--')

it = 0:length(rate_pr)-1;
semilogy(rPR.^(it).*rate0_pr,'Color',hpr,'Linewidth',3,'LineStyle','--')

it = 0:length(rate_dr)-1;
semilogy(rDR.^(it).*rate0_dr,'Color',hdr,'Linewidth',3,'LineStyle','--')


legend( 'Exp. 1-FBS', 'Exp. 2-PR','Exp. 3-DR',...
                'Th. 1-FBS', 'Th. 2-PRS','Th. 3-DRS');
lgd.FontSize = 12;
grid on;
xlim([0,200])
                