clear all
%close all
clc

% load data
hgrad = [ 0 0 204]/255;
hfb2  = [ 153 0 153]/255;
hfb3  = [255 51 153]/255;
hpr   = [100 29 29]/255;
hdr   = [192 135 70]/255;

% Case 1
beta_list = 10.^(linspace( 0.6021,2,50));
eta = (1-sqrt(1-4./beta_list))./(1+sqrt(1-4./beta_list));

figure(1);
semilogy(beta_list,eta./beta_list,'r');hold on;
semilogy(beta_list,(1./eta)./beta_list,'r--');


% Case 2;
beta_list = 10.^(linspace(1.2041,2,50));
rho = 1-8*((sqrt(beta_list) - 2)./beta_list);
hold on
semilogy(beta_list,rho,'b');

% case 3
beta_list = 10.^(linspace( 0.6021,2,50));
rho = 1./(16*beta_list);
hold on
semilogy(beta_list,rho,'g');



% Case 1
beta_list1 = 10.^(linspace( 0.6021,2,50));
eta1 = (1-sqrt(1-4./beta_list))./(1+sqrt(1-4./beta_list));
rho1min = eta1./beta_list1;
rho1max = (1./eta1)./beta_list1;

beta_list2 = 10.^(linspace(1.2041,2,50));
rho2 = 1-8*((sqrt(beta_list2) - 2)./beta_list2);

beta_list3 = 10.^(linspace( 0.6021,2,50));
rho3 = 1./(16*beta_list3);

%%
%
beta_list1 = 10.^(linspace(-4,2,50));
eta1m = 1e-8*ones(size(beta_list1));
eta1M = 1*ones(size(beta_list1));

figure(2);clf
X = [beta_list1,     fliplr(beta_list1)];
Y = [eta1m, fliplr(eta1M)];
C = [0.6235,0.5255,0.5255]%[.9 1 .9];
fill(X,Y,C,'LineStyle','none');
hold on;
%hold on
%plot(beta_list1,rho1min,'r');
%plot(beta_list1,rho1max,'r--');


%


beta_list1 = 10.^(linspace( 0.6021,6,50));
eta1 = (1-sqrt(1-4./beta_list1))./(1+sqrt(1-4./beta_list1));
rho1min = max(1/16,eta1)./beta_list1;
rho1max = (1./eta1)./beta_list1;


X = [beta_list1,     fliplr(beta_list1)];
Y = [rho1min, fliplr(rho1max)];
C = [1 .9 .9];
fill(X,Y,C,'LineStyle','none');
hold on
plot(beta_list1,rho1min,'Color',hfb3);
plot(beta_list1,rho1max,'Color',hfb3);


%

beta_list2 = 10.^(linspace(1.2041,6,50));
rho2 = min(1./(16*beta_list2),1-8*(sqrt(beta_list2)-2)./beta_list2);
tmp = min(rho2);

X = [beta_list2,     fliplr(beta_list2)];
Y = [tmp*ones(size(beta_list2)), fliplr(rho2)];
C = [0.9804,0.8784,0.6314];%%[0.9 .9 1];
fill(X,Y,C,'LineStyle','none');
hold on
plot(beta_list2,rho2,'Color',hdr,'LineStyle','--');
xlim([1e-4,1e4])
ylim([1e-4,1e0])
%
set(gca, 'YScale', 'log')
set(gca, 'XScale', 'log')
set(gca,'FontSize',15)
%
beta_list = 10.^(linspace(-4,6,50));
%plot(beta_list,1.4276e-07*ones(size(beta_list)),'k--');hold on
plot(beta_list,0.0021*ones(size(beta_list)),'k--');
%load beta_value.mat
beta = 1./[1e1,4*1e-2,1e-3];
%plot(beta,1.4276e-07*ones(size(beta)),'ko')
plot(beta,0.0021*ones(size(beta)),'ko')